library EXEPlug_NetBridge;

uses
  Windows,
  SysUtils,
  bsUTILS,
  Classes,
  uSharedDLL in 'uSharedDLL.pas',
  DotNetWrapper in 'DotNetWrapper.pas';






{
  This function is called during Run Time
  Window: Parent setup window handle
  Variables: The names and values of variables used in the setup script
  State: State of plug-in controls, as chosen during compile time
  Progress: Callback function for progress indicator
  Return: Reserved, set to 0
  NewVariables: Plug-in must return variables received, with modifications, here
  See help for details
}
function RunTimeExecute(Window: THandle; Variables, State: PChar; Progress: TPlugProgressIndicator;
  var Return: Integer; NewVariables: PChar): Integer; stdcall; export;

var
  sNewVariables: string;
  sVariables, sState : string;
begin
  InitWrapper;


    // initialize variables
    sVariables := Variables;
    sState := State;
    sNewVariables := NewVariables;




    // call the RunTimeExecute method of the assembly
  Result := Wrapper.Assembly.RunTimeExecute(
    LongInt(Window),
    sVariables, sState,
    LongInt(@Progress),
    Return,
    sNewVariables);

  // Update NewVariables to the parameter returned by the assembly
  StrCopy(NewVariables, PChar(sNewVariables));
end;




exports
  RunTimeExecute;

var
  p: PChar;




begin
  GetMem(p, 1024);
  GetModuleFileName(GetModuleHandle('mEXEPlug.dll'), p, 1024);
  ModuleFile := p;
  ModuleFolder := ExtractFilePath(p);
  FreeMem(p);
end.
